## ausweisapp2 2.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19.0)

set(CMAKE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_DIR}")

include(Policies)

# "tools.only" can be defined to disable the normal build and enable
# cmdline "tools" only. For example: "make format" or "make package_source"
if(tools.only)
	set(LANGUAGES NONE)
else()
	set(LANGUAGES CXX)
endif()

if(UNIX AND NOT IOS)
	set(CMAKE_OSX_DEPLOYMENT_TARGET 12.0 CACHE STRING "Required macOS version")
endif()

project(AusweisApp VERSION 2.1.1 LANGUAGES ${LANGUAGES})

# Set TWEAK if not defined in PROJECT_VERSION above to
# have a valid tweak version without propagating it
if(NOT PROJECT_VERSION_TWEAK)
	set(PROJECT_VERSION_TWEAK 0)
endif()

if(APPLE AND NOT tools.only)
	enable_language(OBJCXX)
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND (IOS OR ANDROID))
	set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/dist" CACHE PATH "default install path" FORCE)
endif()

option(BUILD_SHARED_LIBS "Enable build of shared libraries")
option(INTEGRATED_SDK "Build platform specific SDK" OFF)
option(CONTAINER_SDK "Build container specific SDK" OFF)

if(CONTAINER_SDK)
	set(INTEGRATED_SDK ON)
endif()

include(Helper)

if(NOT VENDOR)
	if(EXISTS "${CMAKE_DIR}/Vendor.internal.cmake")
		include(Vendor.internal)
	else()
		set(VENDOR "") # Qt uses Organization for paths
	endif()
endif()
if(VENDOR MATCHES "Governikus")
	set(VENDOR_GOVERNIKUS TRUE)
	set(LICENSE_FILE "${PROJECT_SOURCE_DIR}/LICENSE.officially.txt")
else()
	set(LICENSE_FILE "${PROJECT_SOURCE_DIR}/LICENSE.txt")
endif()

message(STATUS "VENDOR: ${VENDOR}")
message(STATUS "VERSION: ${PROJECT_VERSION}")

if(ANDROID)
	if(NOT BUILD_PREVIEW)
		set(BUILD_PREVIEW false)
	endif()
	message(STATUS "BUILD_PREVIEW: ${BUILD_PREVIEW}")

	if(NOT ANDROID_VERSION_CODE)
		set(ANDROID_VERSION_CODE 0)
	endif()
	message(STATUS "ANDROID_VERSION_CODE: ${ANDROID_VERSION_CODE}")
endif()

if(IOS OR MAC)
	if(NOT USE_DISTRIBUTION_PROFILE)
		set(USE_DISTRIBUTION_PROFILE false)
	endif()
	message(STATUS "USE_DISTRIBUTION_PROFILE: ${USE_DISTRIBUTION_PROFILE}")
endif()

if("${PROJECT_BINARY_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}" AND NOT FORCE_SOURCE_BUILD)
	message(FATAL_ERROR "in tree building is not supported!")
endif()

if(CMAKE_BUILD_TYPE)
	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
else()
	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(TEST_DIR ${PROJECT_SOURCE_DIR}/test)
set(DOCS_DIR ${PROJECT_SOURCE_DIR}/docs)
set(RESOURCES_DIR ${PROJECT_SOURCE_DIR}/resources)
set(PACKAGING_DIR ${RESOURCES_DIR}/packaging)
set(COPYRIGHT_TEXT "2014-2023 ${VENDOR}")
if(APPLE)
	string(REPLACE " \& " " \&amp; " COPYRIGHT_TEXT ${COPYRIGHT_TEXT})
endif()
set(BUNDLE_IDENTIFIER com.governikus.ausweisapp2)

include(Tools)
include(DVCS)
add_subdirectory(docs)

include(Appcast)
include(Messages)
if(tools.only)
	include(Packaging)
	return()
endif()

if(CMAKE_BUILD_TYPE STREQUAL "DEBUG" AND NOT CONTAINER_SDK)
	set(VALGRIND_SUPPRESSIONS "${CMAKE_PREFIX_PATH}/test/valgrind.supp")
	if(NOT EXISTS "${VALGRIND_SUPPRESSIONS}")
		set(VALGRIND_SUPPRESSIONS "${CMAKE_SOURCE_DIR}/libs/test/valgrind.supp")
	endif()
	message(STATUS "Using valgrind suppressions: ${VALGRIND_SUPPRESSIONS}")
	set(VALGRIND_COMMAND_OPTIONS "--tool=memcheck --leak-check=full --show-leak-kinds=definite --errors-for-leak-kinds=definite --error-exitcode=1 --gen-suppressions=all --suppressions=${VALGRIND_SUPPRESSIONS}")

	include(CTest)
	configure_file("${CMAKE_DIR}/CTestCustom.cmake.in" "${CMAKE_BINARY_DIR}/CTestCustom.cmake" @ONLY)

	set(SONAR_CACHE_DIR ${CMAKE_BINARY_DIR}/../cache)
	if(NOT EXISTS "${SONAR_CACHE_DIR}")
		set(SONAR_CACHE_DIR ${CMAKE_BINARY_DIR})
	endif()
	get_filename_component(SONAR_CACHE_DIR ${SONAR_CACHE_DIR} ABSOLUTE)
	configure_file("${RESOURCES_DIR}/sonar-project.properties.in" "${CMAKE_BINARY_DIR}/sonar-project.properties" @ONLY)
endif()

option(USE_SMARTEID "Enable Smart-eID" OFF)

include(Libraries)
include(Tools.Libraries)
include(CompilerFlags)

if(LINUX OR BSD)
	include(GNUInstallDirs)
endif()

add_subdirectory(resources)
add_subdirectory(src)

if(TARGET ${Qt}::Test AND NOT IOS)
	add_subdirectory(test)
endif()

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/utils")
	add_subdirectory(utils)
endif()

include(Packaging)

include(FeatureSummary)
FEATURE_SUMMARY(WHAT ALL)

=== src/CMakeLists.txt ===
#####################################################################
# The main component that will link all necessary modules and plugins
# into AusweisApp executable for the specific platform.
#
# This component includes a main entry point and command line
# parser only. Everything else will be included from sub-modules.
#####################################################################

add_subdirectory(external)
add_subdirectory(global)
add_subdirectory(secure_storage)
add_subdirectory(settings)

add_subdirectory(file_provider)
add_subdirectory(configuration)
add_subdirectory(network)

add_subdirectory(card)
add_subdirectory(services)

add_subdirectory(diagnosis)
add_subdirectory(ifd)
add_subdirectory(workflows)
add_subdirectory(ui)
add_subdirectory(core)
add_subdirectory(init)
add_subdirectory(whitelist_client)


if(IOS)
	if(NOT INTEGRATED_SDK)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/qml)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/de.lproj)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/launchscreen.storyboard)

		# Attention: the file names correspond to values in the Info.plist
		if(BUILD_PREVIEW)
			message(FATAL_ERROR "iOS preview not implemented")
		elseif(IS_BETA_VERSION)
			set(IOS_APPICON_PATH "beta/")
		else()
			set(IOS_APPICON_PATH "")
		endif()

		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/images/ios/appIcons/${IOS_APPICON_PATH}Images.xcassets)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/Settings.bundle)
		list(APPEND IOS_RESOURCES ${RCC})
		set_source_files_properties(${RCC} PROPERTIES GENERATED TRUE)
	endif()
elseif(MAC)
	if(IS_BETA_VERSION)
		set(MACOS_APPICON_PATH "beta/")
	else()
		set(MACOS_APPICON_PATH "")
	endif()

	list(APPEND MAC_RESOURCES "${RESOURCES_DIR}/images/macos/${MACOS_APPICON_PATH}${PROJECT_NAME}.icns")
	list(APPEND MAC_RESOURCES ${RCC})
	set_source_files_properties(${RCC} PROPERTIES GENERATED TRUE)
endif()

if(APPLE)
	set(CMAKE_XCODE_GENERATE_SCHEME ON)
	set(CMAKE_XCODE_SCHEME_DISABLE_MAIN_THREAD_CHECKER ON)
endif()

set(MAIN_FILE main.cpp)
if(IOS)
	if(INTEGRATED_SDK)
		add_library(AusweisAppBinary SHARED ${MAIN_FILE} ${IOS_RESOURCES})
	else()
		add_executable(AusweisAppBinary MACOSX_BUNDLE ${MAIN_FILE} ${IOS_RESOURCES})
	endif()
elseif(ANDROID OR (INTEGRATED_SDK AND NOT CONTAINER_SDK))
	add_library(AusweisAppBinary SHARED ${MAIN_FILE})
elseif(MAC)
	add_executable(AusweisAppBinary MACOSX_BUNDLE ${MAIN_FILE} ${MAC_RESOURCES})
else()
	add_executable(AusweisAppBinary WIN32 ${MAIN_FILE} windows.rc)
endif()

if(TARGET AusweisAppRcc)
	add_dependencies(AusweisAppBinary AusweisAppRcc)
endif()

target_link_libraries(AusweisAppBinary PRIVATE AusweisAppInit)
if(ANDROID)
	set_target_properties(AusweisAppBinary PROPERTIES OUTPUT_NAME "${PROJECT_NAME}_${CMAKE_ANDROID_ARCH_ABI}")
elseif(IOS AND INTEGRATED_SDK)
	set_target_properties(AusweisAppBinary PROPERTIES OUTPUT_NAME "${PROJECT_NAME}2")
else()
	set_target_properties(AusweisAppBinary PROPERTIES OUTPUT_NAME "${PROJECT_NAME}")
endif()

if(TARGET AusweisAppConfig)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppConfig)
endif()

ADD_SHADERS_TO_TARGET(AusweisAppBinary)

if(APPLE)
	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER "${BUNDLE_IDENTIFIER}")
	set(MACOSX_BUNDLE_COPYRIGHT "${COPYRIGHT_TEXT}")

	if(IOS AND INTEGRATED_SDK)
		set(MACOSX_FRAMEWORK_BUNDLE_VERSION ${PROJECT_VERSION})
		set(MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${PROJECT_VERSION})
		set_target_properties(AusweisAppBinary PROPERTIES MACOSX_FRAMEWORK_NAME ${PROJECT_NAME})
		set_target_properties(AusweisAppBinary PROPERTIES MACOSX_FRAMEWORK_IDENTIFIER "${BUNDLE_IDENTIFIER}")
		set_target_properties(AusweisAppBinary PROPERTIES MACOSX_FRAMEWORK_INFO_PLIST "${PACKAGING_DIR}/ios/Info.framework.plist.in")
	elseif(IOS)
		set_target_properties(AusweisAppBinary PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${PACKAGING_DIR}/ios/Info.plist.in")
	elseif(MAC AND NOT INTEGRATED_SDK)
		set_target_properties(AusweisAppBinary PROPERTIES RESOURCE "${MAC_RESOURCES}")
		set_target_properties(AusweisAppBinary PROPERTIES MACOSX_BUNDLE_ICON_FILE "${PROJECT_NAME}.icns")
		set_target_properties(AusweisAppBinary PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${PACKAGING_DIR}/macos/Info.plist.in")
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_DEBUG_INFORMATION_FORMAT "dwarf-with-dsym")
	endif()
endif()


if(IOS)
	get_target_property(QT_BUILD_TYPE ${Qt}::Core IMPORTED_CONFIGURATIONS)
	if(QT_BUILD_TYPE STREQUAL "DEBUG")
		set(qt_suffix "_debug")
	endif()

	target_link_libraries(AusweisAppBinary PRIVATE OpenSSL::Crypto OpenSSL::SSL) # remove this if iOS uses shared libraries
	target_link_libraries(AusweisAppBinary PRIVATE -L${QT_INSTALL_ARCHDATA}/plugins/platforms)
	target_link_libraries(AusweisAppBinary PRIVATE -L${QT_INSTALL_ARCHDATA}/plugins/imageformats)
	target_link_libraries(AusweisAppBinary PRIVATE -L${QT_INSTALL_ARCHDATA}/lib)
	target_link_libraries(AusweisAppBinary PRIVATE ${Qt}::Core ${Qt}::Network)
	target_link_libraries(AusweisAppBinary PRIVATE -lqios${qt_suffix})

	target_link_libraries(AusweisAppBinary PRIVATE "-lc++ -lz -lm")
	target_link_libraries(AusweisAppBinary PRIVATE ${IOS_ASSETSLIBRARY} ${IOS_UIKIT} ${IOS_COREFOUNDATION} ${IOS_OPENGLES} ${IOS_FOUNDATION} ${IOS_QUARTZCORE} ${IOS_CORETEXT} ${IOS_COREGRAPHICS} ${IOS_SECURITY} ${IOS_NETWORK} ${IOS_MOBILECORESERVICES} ${IOS_AUDIOTOOLBOX} ${IOS_IMAGEIO} ${IOS_CORENFC} ${IOS_MESSAGEUI} ${IOS_STOREKIT})
	target_link_libraries(AusweisAppBinary PRIVATE -Wl,-e,_qt_main_wrapper)

	if(TARGET ${Qt}::Qml)
		target_link_libraries(AusweisAppBinary PRIVATE ${Qt}::Gui ${Qt}::Svg ${Qt}::Qml ${Qt}::Quick ${Qt}::QuickControls2 ${Qt}::QuickTemplates2)
		target_link_libraries(AusweisAppBinary PRIVATE -lqsvg${qt_suffix} -lqjpeg${qt_suffix})
		target_link_libraries(AusweisAppBinary PRIVATE AusweisAppQmlPlugins)
	endif()

	set_target_properties(AusweisAppBinary PROPERTIES RESOURCE "${IOS_RESOURCES}")
	set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_SKIP_INSTALL "NO")
	set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_ASSETCATALOG_COMPILER_APPICON_NAME "AppIcon")
	set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_TARGETED_DEVICE_FAMILY "1,2")
	set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_ENTITLEMENTS "${PACKAGING_DIR}/ios/AusweisApp.entitlements")

	if(INTEGRATED_SDK)
		GET_PUBLIC_HEADER(AusweisAppUiFunctional PUBLIC_HEADER)
		target_sources(AusweisAppBinary PUBLIC ${PUBLIC_HEADER})
		set_target_properties(AusweisAppBinary PROPERTIES FRAMEWORK TRUE FRAMEWORK_VERSION C MACOSX_FRAMEWORK_IDENTIFIER ${BUNDLE_IDENTIFIER})
		set_target_properties(AusweisAppBinary PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION} PUBLIC_HEADER ${PUBLIC_HEADER})
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_INSTALL_PATH "@rpath")
	else()
		if(USE_DISTRIBUTION_PROFILE)
			set(PROVISIONING_PROFILE_SPECIFIER "iOS Release (Distribution)")
			set(EXPORT_METHOD app-store)
			set(XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Distribution: Governikus GmbH & Co. KG (G7EQCJU4BR)")
		else()
			set(PROVISIONING_PROFILE_SPECIFIER "iOS Development")
			set(EXPORT_METHOD development)
			set(XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer: Marco von der Puetten (46ZK7WV8QR)")
		endif()
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_PROVISIONING_PROFILE_SPECIFIER ${PROVISIONING_PROFILE_SPECIFIER})
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_INSTALL_PATH "$(LOCAL_APPS_DIR)")
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ${XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY})
	endif()

	# prevent xcode to convert multiple png files to tiff
	set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_COMBINE_HIDPI_IMAGES "NO")

	configure_file(${PACKAGING_DIR}/ios/exportOptions.plist.in ${CMAKE_BINARY_DIR}/exportOptions.plist @ONLY)
endif()

if(MAC)
	target_link_libraries(AusweisAppBinary PRIVATE ${OSX_APPKIT})

	set(AUTOSTART_HELPER_NAME AutostartHelper)
	set(AUTOSTART_HELPER_FULL_NAME ${PROJECT_NAME}${AUTOSTART_HELPER_NAME})
	set(AUTOSTART_HELPER_SOURCES autostart_helper/main.mm)
	set(AUTOSTART_HELPER_BUNDLE_ID "com.governikus.AusweisApp2.${AUTOSTART_HELPER_NAME}")
	add_executable(${AUTOSTART_HELPER_FULL_NAME} MACOSX_BUNDLE ${AUTOSTART_HELPER_SOURCES})
	target_link_libraries(${AUTOSTART_HELPER_FULL_NAME} ${OSX_APPKIT})
	set_target_properties(${AUTOSTART_HELPER_FULL_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${PACKAGING_DIR}/macos/autostart_helper/Info.plist.in)

	if(USE_DISTRIBUTION_PROFILE)
		configure_file(${PACKAGING_DIR}/macos/entitlements.distribution.plist.in ${CMAKE_BINARY_DIR}/entitlements.plist @ONLY)
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_ENTITLEMENTS "${CMAKE_BINARY_DIR}/entitlements.plist")

		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_DEVELOPMENT_TEAM "G7EQCJU4BR")
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_PROVISIONING_PROFILE_SPECIFIER "macOS Release (Distribution)")
		set_target_properties(AusweisAppBinary PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "3rd Party Mac Developer Application: Governikus GmbH & Co. KG (G7EQCJU4BR)")
	else()
		configure_file(${PACKAGING_DIR}/macos/entitlements.development.plist ${CMAKE_BINARY_DIR}/entitlements.plist COPYONLY)
	endif()
endif()

if(WIN32)
	target_link_libraries(AusweisAppBinary PRIVATE ${WIN_DEFAULT_LIBS})
endif()

#####################################################################
# ui
#####################################################################

if(ANDROID)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiAidl)
	if(NOT INTEGRATED_SDK AND USE_SMARTEID)
		target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiLocalIfd)
	endif()
else()
	target_link_libraries(AusweisAppBinary PRIVATE debug AusweisAppUiAidl)
endif()

if(TARGET ${Qt}::Qml)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiQml)
endif()

if(INTEGRATED_SDK AND NOT ANDROID AND NOT CONTAINER_SDK)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiFunctional)
endif()

if((NOT ANDROID AND NOT IOS AND NOT INTEGRATED_SDK) OR CONTAINER_SDK)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiWebsocket)
endif()

if(CONTAINER_SDK OR DESKTOP)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiAutomatic)
endif()

if(DESKTOP)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiWebservice)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiProxy)
endif()

if((ANDROID OR IOS) AND NOT INTEGRATED_SDK)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppUiScheme)
endif()

#####################################################################
# card
#####################################################################

if(ANDROID)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppCardNfc)
	if(INTEGRATED_SDK AND USE_SMARTEID)
		target_link_libraries(AusweisAppBinary PRIVATE AusweisAppIfdLocal)
	endif()
endif()

if(IOS)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppCardNfc)
endif()

if(TARGET AusweisAppCardSmart)
	if(((ANDROID OR IOS) AND NOT INTEGRATED_SDK) OR CONTAINER_SDK)
		target_link_libraries(AusweisAppBinary PRIVATE AusweisAppCardSmart)
	else()
		target_link_libraries(AusweisAppBinary PRIVATE debug AusweisAppCardSmart)
	endif()
endif()

if(DESKTOP)
	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppCardPcsc AusweisAppCardDrivers)
endif()

target_link_libraries(AusweisAppBinary PRIVATE AusweisAppCardSimulator)

#####################################################################

include(Install)

=== src/ui/qml/CMakeLists.txt ===
############################################################################
# The qml plugin implements the ui interface for desktop and mobile systems.
############################################################################

ADD_PLATFORM_LIBRARY(AusweisAppUiQml)

target_link_libraries(AusweisAppUiQml ${Qt}::Core ${Qt}::Svg ${Qt}::Qml ${Qt}::Quick ${Qt}::QuickControls2)
target_link_libraries(AusweisAppUiQml AusweisAppGlobal AusweisAppUi AusweisAppIfdRemote AusweisAppServices AusweisAppWorkflowsSelfAuth)

target_link_libraries(AusweisAppUiQml ${Qt}::CorePrivate)

if(TARGET ${Qt}::Widgets)
	target_link_libraries(AusweisAppUiQml ${Qt}::Widgets) # QSystemTrayIcon
endif()

if(TARGET ${Qt}::QmlWorkerScript)
	target_link_libraries(AusweisAppUiQml ${Qt}::QmlWorkerScript)
endif()

if(TARGET AusweisAppDiagnosis)
	target_link_libraries(AusweisAppUiQml AusweisAppDiagnosis)
endif()

if(TARGET ${Qt}::WebSockets)
	target_link_libraries(AusweisAppUiQml AusweisAppWorkflowsIfd)
endif()

if(ANDROID)
	target_link_libraries(AusweisAppUiQml AusweisAppWhitelistClient)
else()
	target_link_libraries(AusweisAppUiQml debug AusweisAppWhitelistClient)
endif()

if(MAC)
	target_link_libraries(AusweisAppUiQml ${OSX_USERNOTIFICATIONS})
endif()

if(TARGET AusweisAppWorkflowsPersonalization)
	if((ANDROID OR IOS) AND NOT INTEGRATED_SDK)
		target_link_libraries(AusweisAppUiQml AusweisAppWorkflowsPersonalization)
	else()
		target_link_libraries(AusweisAppUiQml debug AusweisAppWorkflowsPersonalization)
	endif()
endif()

target_compile_definitions(AusweisAppUiQml PRIVATE QT_STATICPLUGIN)

=== debian/changelog ===
ausweisapp2 (2.1.1-1) unstable; urgency=medium

  * New upstream release
  * Replace pkg-config with pkgconf build dependency in debian/control

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 11 Apr 2024 11:15:16 +0200

=== debian/control ===
Source: ausweisapp2
Section: utils
Priority: optional
Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libhttp-parser-dev,
               libpcsclite-dev,
               libqt6opengl6-dev,
               libqt6shadertools6-dev,
               libqt6svg6-dev,
               libqt6websockets6-dev,
               libssl-dev,
               libudev-dev,
               pkgconf,
               qt6-base-dev,
               qt6-base-private-dev,
               qt6-declarative-dev,
               qt6-scxml-dev,
               qt6-tools-dev
Standards-Version: 4.6.1
Homepage: https://www.ausweisapp.bund.de
Vcs-Browser: https://salsa.debian.org/debian/ausweisapp2
Vcs-Git: https://salsa.debian.org/debian/ausweisapp2.git

Package: ausweisapp
Replaces: ausweisapp2 (<< 2.0.0-1~)
Breaks: ausweisapp2 (<< 2.0.0-1~)
Architecture: any
Depends: qml6-module-qt-labs-platform,
         qml6-module-qtqml,
         qml6-module-qtqml-models,
         qml6-module-qtqml-statemachine,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-window,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: pcsc-tools, pcscd
Description: Official authentication app for German ID cards and residence permits
 This app is developed and issued by the German government to be
 used for online authentication with electronic German ID cards
 and residence titles. To use this app, a supported RFID card
 reader or compatible NFC smart phone is required.

Package: ausweisapp2
Depends: ausweisapp, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: Transitional ausweisapp2 dummy package
 This is the transitional ausweisapp2 dummy package. It can safely be removed.

## ausweisapp2 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,29 @@
 	set(CMAKE_OSX_DEPLOYMENT_TARGET 12.0 CACHE STRING "Required macOS version")
 endif()
 
-project(AusweisApp VERSION 2.1.1 LANGUAGES ${LANGUAGES})
+if(CMAKE_BUILD_TYPE)
+	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
+else()
+	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
+endif()
+
+get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
+if(isMultiConfig)
+	if(NOT CMAKE_CONFIGURATION_TYPES)
+		set(CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE})
+	endif()
+
+	list(LENGTH CMAKE_CONFIGURATION_TYPES multiConfigCount)
+	if(NOT multiConfigCount EQUAL 1)
+		message(FATAL_ERROR "Multi-Config builds are not supported: QTBUG-123340")
+	endif()
+endif()
+
+project(AusweisApp VERSION 2.2.0 LANGUAGES ${LANGUAGES})
+
+if(ANDROID AND NOT GOVERNIKUS_TOOLCHAIN_FILE)
+	message(FATAL_ERROR "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_DIR}/android.toolchain.cmake is required")
+endif()
 
 # Set TWEAK if not defined in PROJECT_VERSION above to
 # have a valid tweak version without propagating it
@@ -27,10 +49,6 @@
 
 if(APPLE AND NOT tools.only)
 	enable_language(OBJCXX)
-endif()
-
-if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND (IOS OR ANDROID))
-	set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/dist" CACHE PATH "default install path" FORCE)
 endif()
 
 option(BUILD_SHARED_LIBS "Enable build of shared libraries")
@@ -83,12 +101,6 @@
 	message(FATAL_ERROR "in tree building is not supported!")
 endif()
 
-if(CMAKE_BUILD_TYPE)
-	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
-else()
-	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
-endif()
-
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
 
@@ -97,11 +109,15 @@
 set(DOCS_DIR ${PROJECT_SOURCE_DIR}/docs)
 set(RESOURCES_DIR ${PROJECT_SOURCE_DIR}/resources)
 set(PACKAGING_DIR ${RESOURCES_DIR}/packaging)
-set(COPYRIGHT_TEXT "2014-2023 ${VENDOR}")
+set(COPYRIGHT_TEXT "2014-2024 ${VENDOR}")
 if(APPLE)
 	string(REPLACE " \& " " \&amp; " COPYRIGHT_TEXT ${COPYRIGHT_TEXT})
 endif()
 set(BUNDLE_IDENTIFIER com.governikus.ausweisapp2)
+
+if(NOT CONTAINER_SDK)
+	include(CTest)
+endif()
 
 include(Tools)
 include(DVCS)
@@ -114,7 +130,30 @@
 	return()
 endif()
 
-if(CMAKE_BUILD_TYPE STREQUAL "DEBUG" AND NOT CONTAINER_SDK)
+option(USE_SMARTEID "Enable Smart-eID" OFF)
+
+include(Libraries)
+include(PoliciesQt)
+include(Tools.Libraries)
+include(CompilerFlags)
+
+if(LINUX OR BSD)
+	include(GNUInstallDirs)
+endif()
+
+add_subdirectory(resources)
+add_subdirectory(src)
+if(BUILD_TESTING)
+	add_subdirectory(test)
+endif()
+
+if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/utils")
+	add_subdirectory(utils)
+endif()
+
+include(Packaging)
+
+if(BUILD_TESTING)
 	set(VALGRIND_SUPPRESSIONS "${CMAKE_PREFIX_PATH}/test/valgrind.supp")
 	if(NOT EXISTS "${VALGRIND_SUPPRESSIONS}")
 		set(VALGRIND_SUPPRESSIONS "${CMAKE_SOURCE_DIR}/libs/test/valgrind.supp")
@@ -122,7 +161,6 @@
 	message(STATUS "Using valgrind suppressions: ${VALGRIND_SUPPRESSIONS}")
 	set(VALGRIND_COMMAND_OPTIONS "--tool=memcheck --leak-check=full --show-leak-kinds=definite --errors-for-leak-kinds=definite --error-exitcode=1 --gen-suppressions=all --suppressions=${VALGRIND_SUPPRESSIONS}")
 
-	include(CTest)
 	configure_file("${CMAKE_DIR}/CTestCustom.cmake.in" "${CMAKE_BINARY_DIR}/CTestCustom.cmake" @ONLY)
 
 	set(SONAR_CACHE_DIR ${CMAKE_BINARY_DIR}/../cache)
@@ -133,28 +171,5 @@
 	configure_file("${RESOURCES_DIR}/sonar-project.properties.in" "${CMAKE_BINARY_DIR}/sonar-project.properties" @ONLY)
 endif()
 
-option(USE_SMARTEID "Enable Smart-eID" OFF)
-
-include(Libraries)
-include(Tools.Libraries)
-include(CompilerFlags)
-
-if(LINUX OR BSD)
-	include(GNUInstallDirs)
-endif()
-
-add_subdirectory(resources)
-add_subdirectory(src)
-
-if(TARGET ${Qt}::Test AND NOT IOS)
-	add_subdirectory(test)
-endif()
-
-if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/utils")
-	add_subdirectory(utils)
-endif()
-
-include(Packaging)
-
 include(FeatureSummary)
 FEATURE_SUMMARY(WHAT ALL)

=== libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.0)

if(POLICY CMP0010)
	cmake_policy(SET CMP0010 NEW)
endif()

if(POLICY CMP0020)
	cmake_policy(SET CMP0020 NEW)
endif()

if(POLICY CMP0135)
	cmake_policy(SET CMP0135 NEW)
endif()

if(NOT ANDROID AND NOT IOS)
	set(COMPILER_SEARCH C CXX)
endif()

project(AusweisApp2_Libs ${COMPILER_SEARCH})

option(INTEGRATED_SDK "Build integrated specific SDK" OFF)
option(CONTAINER_SDK "Build container specific SDK" OFF)
option(DEVELOPER "Include modules/features for developer" OFF)

if(CONTAINER_SDK)
	set(INTEGRATED_SDK ON)
	set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/../cmake;${PROJECT_SOURCE_DIR}")
else()
	set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/../cmake")
endif()

include(ExternalProject)
include(Helper)
include(DVCS)


if(MSVC)
	find_program(MAKE jom CMAKE_FIND_ROOT_PATH_BOTH)
	if(NOT MAKE)
		find_program(MAKE nmake CMAKE_FIND_ROOT_PATH_BOTH)
	endif()
else()
	find_program(MAKE make CMAKE_FIND_ROOT_PATH_BOTH)
endif()

if(MINGW AND NOT MAKE)
	find_program(MAKE mingw32-make CMAKE_FIND_ROOT_PATH_BOTH)
endif()

if(MAKE)
	message(STATUS "Using 'make' command... ${MAKE}")
else()
	message(FATAL_ERROR "Cannot find 'make' command")
endif()

if(NOT DEFINED PROCESSOR_COUNT)
	set(PROCESSOR_COUNT $ENV{PROCESSOR_COUNT})
endif()

if(NOT DEFINED PROCESSOR_COUNT)
	include(ProcessorCount)
	ProcessorCount(PROCESSOR_COUNT)
endif()

if(NOT PROCESSOR_COUNT EQUAL 0 AND NOT MAKE MATCHES "nmake")
	set(MAKE_JOBS -j${PROCESSOR_COUNT})
	message(STATUS "PROCESSOR_COUNT: ${PROCESSOR_COUNT}")
endif()

if(CMAKE_BUILD_TYPE)
	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
else()
	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
endif()

if(NOT ${CMAKE_BUILD_TYPE} STREQUAL "DEBUG" AND NOT ${CMAKE_BUILD_TYPE} STREQUAL "RELEASE" AND NOT ${CMAKE_BUILD_TYPE} STREQUAL "RELWITHDEBINFO")
	message(FATAL_ERROR "CMAKE_BUILD_TYPE is invalid! Available options: RELEASE, RELWITHDEBINFO, DEBUG")
endif()

if(MSVC)
	FIND_HOST_PACKAGE(Perl REQUIRED)
else()
	set(PERL_EXECUTABLE perl)
endif()

set(PATCH_CMAKE ${CMAKE_CURRENT_BINARY_DIR}/patch.cmake)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/patch.cmake.in ${PATCH_CMAKE} @ONLY)

if(NOT DESTINATION_DIR)
	set(DESTINATION_DIR ${PROJECT_BINARY_DIR}/dist)
endif()

configure_file(${PROJECT_SOURCE_DIR}/test/valgrind.supp.${CMAKE_BUILD_TYPE} ${DESTINATION_DIR}/test/valgrind.supp COPYONLY)

if(NOT PACKAGES_DIR)
	set(PACKAGES_DIR $ENV{PACKAGES_DIR})
	if(NOT PACKAGES_DIR)
		message(STATUS "Define PACKAGES_DIR for local packages")
		set(PACKAGES_DIR ${PROJECT_BINARY_DIR}/download)
	endif()
endif()

string(REPLACE "\\" "/" PACKAGES_DIR ${PACKAGES_DIR})
set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_CURRENT_BINARY_DIR}/b)
include(Messages)

if(NOT CMAKE_HOST_SYSTEM_NAME STREQUAL CMAKE_SYSTEM_NAME)
	get_filename_component(compiler "${CMAKE_CXX_COMPILER}" NAME)
	string(REGEX REPLACE "[a-z|+]+$" "" CROSS_PREFIX "${compiler}")
endif()

################################## Versions
include(Versions.cmake)

################################## Files
set(QT_FILE qt-everywhere-src-${QT}.tar.xz)
set(OPENSSL_FILE openssl-${OPENSSL}.tar.gz)

################################## Downloads
if("${QT}" MATCHES "alpha|beta|rc")
	set(QT_DEST_DIR development_releases)
else()
	set(QT_DEST_DIR archive) # official_releases
endif()

string(REPLACE "." ";" QT_VERSION_LIST ${QT})
list(GET QT_VERSION_LIST 0 QT_MAJOR_VERSION)
list(GET QT_VERSION_LIST 1 QT_MINOR_VERSION)
set(QT_SUBVERSION ${QT_MAJOR_VERSION}.${QT_MINOR_VERSION})
list(APPEND QT_URLS https://download.qt.io/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})
list(APPEND QT_URLS https://ftp.fau.de/qtproject/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})

set(OPENSSL_SOURCE https://www.openssl.org/source)
if("${OPENSSL}" MATCHES "SNAP")
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/snapshot/${OPENSSL_FILE})
else()
	string(SUBSTRING ${OPENSSL} 0 5 OPENSSL_SUBVERSION)
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/${OPENSSL_FILE})
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/old/${OPENSSL_SUBVERSION}/${OPENSSL_FILE})
endif()



set(ENABLED_TARGETS)

################################## OpenSSL
#########################################################################
list(APPEND ENABLED_TARGETS openssl)

set(OPENSSL_CONFIGURE_FLAGS no-camellia no-bf no-aria no-seed no-poly1305 no-srp no-gost no-idea no-mdc2 no-rc2 no-rc4 no-rc5 no-srtp no-sm2 no-sm3 no-sm4)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-ct no-dgram no-cast no-chacha no-blake2 no-rmd160 no-scrypt no-siphash no-whirlpool no-md4 no-des no-ec2m)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-tls1 no-tls1-method no-tls1_1 no-tls1_1-method no-tls1_3 no-ssl3 no-ssl3-method no-dtls no-dtls1-method no-dtls1_2-method)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-deprecated no-engine no-async no-dso no-comp no-ts no-makedepend no-tests no-legacy shared)

if(${CMAKE_BUILD_TYPE} STREQUAL "DEBUG")
	set(OPENSSL_CONFIGURE_FLAGS --debug ${OPENSSL_CONFIGURE_FLAGS})
	if(MSVC)
		ADD_FLAG(/Od NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
	endif()
else()
	set(OPENSSL_CONFIGURE_FLAGS no-ui-console no-filenames ${OPENSSL_CONFIGURE_FLAGS})
	ADD_FLAG(-Os NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
endif()

if(WIN32)
	ADD_FLAG(-Wl,--dynamicbase NOQUOTES VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)
	ADD_FLAG(-Wl,--nxcompat NOQUOTES VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)
	ADD_FLAG(-Wl,--high-entropy-va NOQUOTES VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)

	if(MSVC AND MAKE MATCHES "jom")
		ADD_FLAG(/FS NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
	endif()
else()
	ADD_FLAG(-fstack-protector-strong -fstack-protector NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
endif()

if(IOS)
	set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-asm)
	if(CMAKE_OSX_SYSROOT MATCHES "iphonesimulator")
		set(OPENSSL_ARCH iossimulator-xcrun)
		if (CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
			set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} "-arch arm64")
		endif()
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mios-simulator-version-min=${CMAKE_OSX_DEPLOYMENT_TARGET})
	else()
		set(OPENSSL_ARCH ios64-cross)
		string(REGEX REPLACE "/SDKs/.*" "" CROSS_TOP_DEV_ROOT "${CMAKE_OSX_SYSROOT}")
		set(OPENSSL_ENV CROSS_TOP=${CROSS_TOP_DEV_ROOT} CROSS_SDK=iPhoneOS.sdk)
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mios-version-min=${CMAKE_OSX_DEPLOYMENT_TARGET})
	endif()
	set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -fvisibility=hidden)
elseif(APPLE)
	if(NOT CMAKE_OSX_ARCHITECTURES AND CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "arm64")
		set(CMAKE_OSX_ARCHITECTURES arm64)
	endif()

	if(CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
		set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-asm)
		set(OPENSSL_ARCH darwin64-arm64-cc)
	else()
		set(OPENSSL_ARCH darwin64-x86_64-cc)
	endif()

	set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mmacosx-version-min=12.0)
elseif(MINGW OR CYGWIN)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(OPENSSL_ARCH mingw64)
	else()
		set(OPENSSL_ARCH mingw)
	endif()

	if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux")
		set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} --cross-compile-prefix=${CROSS_PREFIX})
	endif()
elseif(MSVC)
	set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-asm)
	if(CMAKE_SYSTEM_PROCESSOR STREQUAL "AMD64")
		set(OPENSSL_ARCH VC-WIN64A)
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86")
		set(OPENSSL_ARCH VC-WIN32)
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "ARM64")
		set(OPENSSL_ARCH VC-WIN64-ARM)
	else()
		message(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR not supported by openssl: ${CMAKE_SYSTEM_PROCESSOR}")
	endif()
elseif(ANDROID)
	if(CMAKE_ANDROID_ARCH_ABI STREQUAL "armeabi-v7a")
		set(OPENSSL_ARCH android-arm)
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mfloat-abi=softfp)
		set(OPENSSL_NDK_PREFIX armv7a)
		set(OPENSSL_NDK_INFIX eabi)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "x86_64")
		set(OPENSSL_ARCH android-x86_64)
		set(OPENSSL_NDK_PREFIX x86_64)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "x86")
		set(OPENSSL_ARCH android-x86)
		set(OPENSSL_NDK_PREFIX i686)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "arm64-v8a")
		set(OPENSSL_ARCH android-arm64)
		set(OPENSSL_NDK_PREFIX aarch64)
	else()
		message(FATAL_ERROR "CMAKE_ANDROID_ARCH_ABI not supported by openssl: ${CMAKE_ANDROID_ARCH_ABI}")
	endif()
	set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-stdio)

	get_filename_component(toolchain_bin "${CMAKE_C_COMPILER}" DIRECTORY)
	set(OPENSSL_ENV PATH=${toolchain_bin}/:$ENV{PATH} CC=clang CXX=clang++)

	if(ANDROID_NDK_REVISION VERSION_LESS "23")
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -D__ANDROID_API__=${CMAKE_SYSTEM_VERSION})
	endif()
	set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} --target=${OPENSSL_NDK_PREFIX}-linux-android${OPENSSL_NDK_INFIX}${CMAKE_SYSTEM_VERSION})
elseif(BSD)
	if(CMAKE_SYSTEM_PROCESSOR STREQUAL "amd64")
		set(OPENSSL_ARCH BSD-x86_64)
	else()
		message(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR not supported by openssl: ${CMAKE_SYSTEM_PROCESSOR}")
	endif()
elseif(LINUX)
	if(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
		set(OPENSSL_ARCH linux-x86_64)
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86")
		set(OPENSSL_ARCH linux-x86)
	elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
		set(OPENSSL_ARCH linux-aarch64)
	elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "arm")
		set(OPENSSL_ARCH linux-armv4)
	else()
		message(FATAL_ERROR "CMAKE_SYSTEM_PROCESSOR not supported by openssl: ${CMAKE_SYSTEM_PROCESSOR}")
	endif()
else()
	message(FATAL_ERROR "Unsupported system")
endif()

if(OPENSSL_ENV)
	set(OPENSSL_ENV ${CMAKE_COMMAND} -E env ${OPENSSL_ENV})
endif()

ExternalProject_Add(openssl
	URL ${OPENSSL_URLS}
	URL_HASH SHA256=${OPENSSL_HASH}
	DOWNLOAD_DIR ${PACKAGES_DIR}

	PATCH_COMMAND ${CMAKE_COMMAND} -DCOMPONENT=openssl -P ${PATCH_CMAKE}
	CONFIGURE_COMMAND ${OPENSSL_ENV} ${PERL_EXECUTABLE} <SOURCE_DIR>/Configure --prefix=${DESTINATION_DIR} --libdir=lib ${OPENSSL_CONFIGURE_FLAGS} ${OPENSSL_ARCH} "${OPENSSL_COMPILER_FLAGS}"
	BUILD_COMMAND ${OPENSSL_ENV} ${MAKE} ${MAKE_JOBS}
	INSTALL_COMMAND ${OPENSSL_ENV} ${MAKE} ${MAKE_JOBS} install_sw
)

ExternalProject_Add_Step(openssl configdata
	COMMAND ${PERL_EXECUTABLE} configdata.pm --dump
	DEPENDEES configure
	DEPENDERS build
	WORKING_DIRECTORY <BINARY_DIR>)


if(MAC)
	set(OPENSSL_FILE_VERSION 3)
	add_custom_command(TARGET openssl POST_BUILD
		COMMAND install_name_tool -id @rpath/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}
		COMMAND install_name_tool -id @rpath/libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}
		COMMAND install_name_tool -change ${DESTINATION_DIR}/lib/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} @rpath/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

if(IOS)
	# Remove this work-around! Do not build any .dylib or be able to use .dylib
	# Globbing is not supported by cmake command mode! This will work if executed with unix shell only.
	if(CMAKE_VERSION VERSION_LESS "3.17")
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E remove ${DESTINATION_DIR}/lib/*.dylib)
	else()
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E rm -f ${DESTINATION_DIR}/lib/*.dylib)
	endif()
elseif(ANDROID)
	if(CMAKE_VERSION VERSION_LESS "3.17")
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E remove ${DESTINATION_DIR}/lib/*.a)
	else()
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E rm -f ${DESTINATION_DIR}/lib/*.a)
	endif()
endif()

################################## Qt
#########################################################################
list(APPEND ENABLED_TARGETS qt)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,10 @@
 add_subdirectory(ui)
 add_subdirectory(core)
 add_subdirectory(init)
-add_subdirectory(whitelist_client)
 
 
 if(IOS)
 	if(NOT INTEGRATED_SDK)
-		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/qml)
 		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/de.lproj)
 		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/launchscreen.storyboard)
 
@@ -72,7 +70,15 @@
 		add_executable(AusweisAppBinary MACOSX_BUNDLE ${MAIN_FILE} ${IOS_RESOURCES})
 	endif()
 elseif(ANDROID OR (INTEGRATED_SDK AND NOT CONTAINER_SDK))
-	add_library(AusweisAppBinary SHARED ${MAIN_FILE})
+	if(INTEGRATED_SDK)
+		add_library(AusweisAppBinary SHARED ${MAIN_FILE})
+	else()
+		qt_add_executable(AusweisAppBinary ${MAIN_FILE})
+		set_target_properties(AusweisAppBinary PROPERTIES QT_ANDROID_PACKAGE_SOURCE_DIR "${ANDROID_PACKAGE_SRC_DIR}")
+		set_target_properties(AusweisAppBinary PROPERTIES QT_ANDROID_MIN_SDK_VERSION ${CMAKE_SYSTEM_VERSION})
+		set_target_properties(AusweisAppBinary PROPERTIES QT_ANDROID_TARGET_SDK_VERSION ${ANDROID_TARGET_SDK_VERSION})
+		set_target_properties(AusweisAppBinary PROPERTIES QT_QML_ROOT_PATH $<TARGET_PROPERTY:AusweisAppUiQmlModules,BINARY_DIR>/${CMAKE_SYSTEM_NAME})
+	endif()
 elseif(MAC)
 	add_executable(AusweisAppBinary MACOSX_BUNDLE ${MAIN_FILE} ${MAC_RESOURCES})
 else()
@@ -84,7 +90,7 @@
 endif()
 
 target_link_libraries(AusweisAppBinary PRIVATE AusweisAppInit)
-if(ANDROID)
+if(ANDROID AND INTEGRATED_SDK)
 	set_target_properties(AusweisAppBinary PROPERTIES OUTPUT_NAME "${PROJECT_NAME}_${CMAKE_ANDROID_ARCH_ABI}")
 elseif(IOS AND INTEGRATED_SDK)
 	set_target_properties(AusweisAppBinary PROPERTIES OUTPUT_NAME "${PROJECT_NAME}2")
@@ -101,7 +107,6 @@
 if(APPLE)
 	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
 	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
-	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
 	set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
 	set(MACOSX_BUNDLE_GUI_IDENTIFIER "${BUNDLE_IDENTIFIER}")
 	set(MACOSX_BUNDLE_COPYRIGHT "${COPYRIGHT_TEXT}")
@@ -143,7 +148,6 @@
 	if(TARGET ${Qt}::Qml)
 		target_link_libraries(AusweisAppBinary PRIVATE ${Qt}::Gui ${Qt}::Svg ${Qt}::Qml ${Qt}::Quick ${Qt}::QuickControls2 ${Qt}::QuickTemplates2)
 		target_link_libraries(AusweisAppBinary PRIVATE -lqsvg${qt_suffix} -lqjpeg${qt_suffix})
-		target_link_libraries(AusweisAppBinary PRIVATE AusweisAppQmlPlugins)
 	endif()
 
 	set_target_properties(AusweisAppBinary PROPERTIES RESOURCE "${IOS_RESOURCES}")
@@ -268,11 +272,3 @@
 endif()
 
 if(DESKTOP)
-	target_link_libraries(AusweisAppBinary PRIVATE AusweisAppCardPcsc AusweisAppCardDrivers)
-endif()
-
-target_link_libraries(AusweisAppBinary PRIVATE AusweisAppCardSimulator)
-
-#####################################################################
-
-include(Install)

=== test/tools/CMakeLists.txt ===
find_program(JSONSCHEMA_BIN NAMES check-jsonschema jsonschema jsonschema-3 python-jsonschema python3-jsonschema py-jsonschema py3-jsonschema CMAKE_FIND_ROOT_PATH_BOTH)

if(JSONSCHEMA_BIN)
	set(JSON_FILES updatable-files/supported-providers.json updatable-files/supported-readers.json)

	foreach(jsonfile ${JSON_FILES})
		set(file ${RESOURCES_DIR}/${jsonfile})
		if(NOT EXISTS "${file}")
			message(FATAL_ERROR "File does not exist: ${file}")
		endif()

		get_filename_component(filename ${file} NAME)
		set(schema ${CMAKE_CURRENT_SOURCE_DIR}/${filename})

		if(JSONSCHEMA_BIN MATCHES "check-jsonschema")
			add_test(NAME ${filename} COMMAND ${JSONSCHEMA_BIN} --schemafile ${schema} ${file})
		else()
			add_test(NAME ${filename} COMMAND ${JSONSCHEMA_BIN} -i ${file} ${schema})
		endif()
		set_tests_properties(${filename} PROPERTIES LABELS "json" TIMEOUT 10)
	endforeach()
endif()


if(TARGET ${Qt}::Qml AND QT_VERSION VERSION_GREATER_EQUAL 6.5)
	add_test(NAME qmldir
			COMMAND ${CMAKE_COMMAND} -DCMD=CHECK_QMLDIR -P ${CMAKE_DIR}/cmd.cmake
			WORKING_DIRECTORY $<TARGET_PROPERTY:AusweisAppUiQmlModules,BINARY_DIR>)
	set_tests_properties(qmldir PROPERTIES LABELS "qml")

	add_test(NAME qmltypes
			COMMAND ${CMAKE_COMMAND} -DCMD=CHECK_QMLTYPES -P ${CMAKE_DIR}/cmd.cmake
			WORKING_DIRECTORY $<TARGET_PROPERTY:AusweisAppUiQmlModules,BINARY_DIR>)
	set_tests_properties(qmltypes PROPERTIES LABELS "qml")

	add_test(NAME qmllint
			COMMAND ${CMAKE_COMMAND} --build . --target all_qmllint
			WORKING_DIRECTORY ${PROJECT_BINARY_DIR})
	set_tests_properties(qmllint PROPERTIES LABELS "qml")
endif()

=== src/ui/qml/CMakeLists.txt ===
############################################################################
# The qml plugin implements the ui interface for desktop and mobile systems.
############################################################################

add_subdirectory(modules)

ADD_PLATFORM_LIBRARY(AusweisAppUiQml EXCLUDE "/modules/")

target_link_libraries(AusweisAppUiQml PUBLIC ${Qt}::Core ${Qt}::Svg ${Qt}::Qml ${Qt}::Quick ${Qt}::QuickControls2)
target_link_libraries(AusweisAppUiQml PUBLIC AusweisAppGlobal AusweisAppUi AusweisAppIfdRemote AusweisAppServices AusweisAppWorkflowsSelfAuth AusweisAppUiQmlModules)

target_link_libraries(AusweisAppUiQml PUBLIC ${Qt}::CorePrivate)

if(TARGET ${Qt}::Widgets)
	target_link_libraries(AusweisAppUiQml PUBLIC ${Qt}::Widgets) # QSystemTrayIcon
endif()

if(TARGET ${Qt}::QmlWorkerScript)
	target_link_libraries(AusweisAppUiQml PUBLIC ${Qt}::QmlWorkerScript)
endif()

if(TARGET AusweisAppDiagnosis)
	target_link_libraries(AusweisAppUiQml PUBLIC AusweisAppDiagnosis)
endif()

if(TARGET ${Qt}::WebSockets)
	target_link_libraries(AusweisAppUiQml PUBLIC AusweisAppWorkflowsIfd)
endif()

if(MAC)
	target_link_libraries(AusweisAppUiQml PUBLIC ${OSX_USERNOTIFICATIONS})
endif()

if(TARGET AusweisAppWorkflowsPersonalization)
	if((ANDROID OR IOS) AND NOT INTEGRATED_SDK)
		target_link_libraries(AusweisAppUiQml PUBLIC AusweisAppWorkflowsPersonalization)
	else()
		target_link_libraries(AusweisAppUiQml PUBLIC debug AusweisAppWorkflowsPersonalization)
	endif()
endif()

target_compile_definitions(AusweisAppUiQml PRIVATE QT_STATICPLUGIN)


qt_add_qml_module(AusweisAppUiQml
	URI "Governikus.Type"
	VERSION "${PROJECT_VERSION}"
	OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/modules/common/Governikus/Type
	RESOURCE_PREFIX /qml
	NO_CACHEGEN
	NO_IMPORT_SCAN
	DEPENDENCIES QtQml QtQml.Models QtQuick
)

get_target_property(target_type AusweisAppUiQmlplugin TYPE)
if(target_type STREQUAL STATIC_LIBRARY)
	target_link_libraries(AusweisAppUiQml PRIVATE AusweisAppUiQmlplugin)
endif()

if(QT_VERSION VERSION_GREATER_EQUAL "6.7.1"
		OR (QT_VERSION VERSION_GREATER_EQUAL "6.5.6" AND QT_VERSION VERSION_LESS "6.6")
	)
	if(TARGET AusweisAppDiagnosis)
		qt_generate_foreign_qml_types(AusweisAppDiagnosis AusweisAppUiQml)
	endif()
	qt_generate_foreign_qml_types(AusweisAppGlobal AusweisAppUiQml)
	qt_generate_foreign_qml_types(AusweisAppUi AusweisAppUiQml)
	qt_generate_foreign_qml_types(AusweisAppCard AusweisAppUiQml)
else()
	set_property(SOURCE UiPluginQml.cpp PROPERTY COMPILE_DEFINITIONS USE_CUSTOM_REGISTRATION)
endif()

=== debian/changelog ===
ausweisapp2 (2.2.0-2ubuntu1) plucky; urgency=medium

  * Rebuild against Qt 6.7.2 private-abi.
  * Build depend on qt6-*-dev instead of removed virtual
    packages..

 -- Rik Mills <rikmills@kde.org>  Thu, 17 Oct 2024 17:49:00 +0100

ausweisapp2 (2.2.0-2) unstable; urgency=medium

  * Add patch to fix compatibility with QML 6.6 (Closes: #1076424)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 16 Jul 2024 15:12:30 +0200

ausweisapp2 (2.2.0-1) unstable; urgency=medium

  * New upstream release
  * Add empty override_dh_auto_test target in debian/rules

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Tue, 09 Jul 2024 10:41:23 +0200

ausweisapp2 (2.1.1-2) unstable; urgency=medium

  * Add libqt6svg6 to Depends for ausweisapp package
    in debian/control (Closes: #1070018)
  * Add qml6-module-qtquick-effects to Depends for
    ausweisapp package in debian/control (Closes: #1073063)

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sat, 15 Jun 2024 11:14:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: ausweisapp2
 Section: utils
 Priority: optional
-Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
 Build-Depends: cmake,
                debhelper-compat (= 12),
                libhttp-parser-dev,
                libpcsclite-dev,
                libqt6opengl6-dev,
-               libqt6shadertools6-dev,
-               libqt6svg6-dev,
-               libqt6websockets6-dev,
                libssl-dev,
                libudev-dev,
                pkgconf,
@@ -17,7 +15,10 @@
                qt6-base-private-dev,
                qt6-declarative-dev,
                qt6-scxml-dev,
-               qt6-tools-dev
+               qt6-svg-dev,
+               qt6-shadertools-dev,
+               qt6-tools-dev,
+               qt6-websockets-dev
 Standards-Version: 4.6.1
 Homepage: https://www.ausweisapp.bund.de
 Vcs-Browser: https://salsa.debian.org/debian/ausweisapp2
@@ -27,12 +28,14 @@
 Replaces: ausweisapp2 (<< 2.0.0-1~)
 Breaks: ausweisapp2 (<< 2.0.0-1~)
 Architecture: any
-Depends: qml6-module-qt-labs-platform,
+Depends: libqt6svg6,
+         qml6-module-qt-labs-platform,
          qml6-module-qtqml,
          qml6-module-qtqml-models,
          qml6-module-qtqml-statemachine,
          qml6-module-qtqml-workerscript,
          qml6-module-qtquick-controls,
+         qml6-module-qtquick-effects,
          qml6-module-qtquick-layouts,
          qml6-module-qtquick-templates,
          qml6-module-qtquick-window,

## ausweisapp2 2.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -35,7 +35,7 @@
 	endif()
 endif()
 
-project(AusweisApp VERSION 2.2.0 LANGUAGES ${LANGUAGES})
+project(AusweisApp VERSION 2.2.1 LANGUAGES ${LANGUAGES})
 
 if(ANDROID AND NOT GOVERNIKUS_TOOLCHAIN_FILE)
 	message(FATAL_ERROR "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_DIR}/android.toolchain.cmake is required")

=== debian/changelog ===
ausweisapp2 (2.2.1-2) unstable; urgency=medium

  * Update Build-Depends in debian/control (Closes: #1084146)
    - Remove libqt6opengl6-dev
    - Rename libqt6shadertools6-dev to qt6-shadertools-dev
    - Rename libqt6svg6-dev to qt6-svg-dev
    - Rename libqt6websockets6-dev to qt6-websockets-dev

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 13 Oct 2024 12:47:06 +0200

ausweisapp2 (2.2.1-1) unstable; urgency=medium

  * New upstream release
  * Drop 0001-Fix-QML-error-with-Qt-6.6.3.patch, fixed upstream

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 11 Sep 2024 16:43:40 +0200
